#include <sys/types.h>
#include <time.h>
#include "buffer.h"
#include "logmsg.h"
#include "getln.h"
#include "mess822.h"
#include "exit.h"
#include "leapsecs.h"
#include "caltime.h"
#include "tai.h"

#define WHO "822date"

void nomem()
{
  logmsg(WHO,111,FATAL,"out of memory");
}

mess822_time t;
struct tai sec;
unsigned char secpack[TAI_PACK];
time_t secunix;

mess822_header h = MESS822_HEADER;
mess822_action a[] = {
  { "date", 0, 0, 0, 0, &t }
, { 0, 0, 0, 0, 0, 0 }
} ;

stralloc line = {0};
int match;

int main(int argc,char **argv)
{
  if (leapsecs_init() == -1)
    logmsg(WHO,111,FATAL,"unable to init leapsecs: ");

  if (argv[1])
    a[0].name = argv[1];

  if (!mess822_begin(&h,a)) nomem();
  for (;;) {
    if (getln(buffer_0,&line,&match,'\n') == -1)
      logmsg(WHO,111,FATAL,"unable to read input: ");
    if (!mess822_ok(&line)) break;
    if (!mess822_line(&h,&line)) nomem();
    if (!match) break;
  }
  if (!mess822_end(&h)) nomem();

  if (!t.known) _exit(100);

  if (!stralloc_ready(&line,caltime_fmt((char *) 0,&t.ct))) nomem();
  buffer_put(buffer_1,line.s,caltime_fmt(line.s,&t.ct));
  buffer_put(buffer_1,"\n",1);

  caltime_tai(&t.ct,&sec);

  caltime_utc(&t.ct,&sec,(int *) 0,(int *) 0);
  if (!stralloc_ready(&line,caltime_fmt((char *) 0,&t.ct))) nomem();
  buffer_put(buffer_1,line.s,caltime_fmt(line.s,&t.ct));
  buffer_put(buffer_1,"\n",1);

  tai_pack((char *)secpack,&sec);
  secunix = secpack[0] - 64;
  secunix = (secunix << 8) + secpack[1];
  secunix = (secunix << 8) + secpack[2];
  secunix = (secunix << 8) + secpack[3];
  secunix = (secunix << 8) + secpack[4];
  secunix = (secunix << 8) + secpack[5];
  secunix = (secunix << 8) + secpack[6];
  secunix = (secunix << 8) + secpack[7];
  secunix -= 10;
  buffer_puts(buffer_1,ctime(&secunix));

  buffer_flush(buffer_1);
  _exit(0);
}
