#include "buffer.h"
#include "logmsg.h"
#include "getln.h"
#include "mess822.h"
#include "case.h"
#include "exit.h"
#include "str.h"

#define WHO "822field"

void nomem()
{
  logmsg(WHO,111,FATAL,"out of memory");
}

int flag;
stralloc value = {0};

mess822_header h = MESS822_HEADER;
mess822_action a[] = {
  { "subject", &flag, 0, &value, 0, 0 }
, { 0, 0, 0, 0, 0, 0 }
} ;

stralloc line = {0};
int match;

int main(int argc,char **argv)
{
  int verbose = 0;

  if (argv[1]) {
    if (*argv[1] == '+') {
      verbose = 1;
      if (str_len(argv[1]) == 1)
        a[0].name = "subject";
      else
        a[0].name = argv[1] + 1;
    } else
      a[0].name = argv[1];
  }

  if (!mess822_begin(&h,a)) nomem();
  *a->flag = 1; /* be verbose */
  if (verbose) *a->flag = 2;

  for (;;) {
    if (getln(buffer_0,&line,&match,'\n') == -1)
      logmsg(WHO,111,FATAL,"unable to read input ");

    if (!mess822_ok(&line)) break;
    if (!mess822_line(&h,&line)) nomem();
    if (!match) break;
  }

  if (!mess822_end(&h)) nomem();

  buffer_putflush(buffer_1,value.s,value.len);

  _exit(flag ? 0 : 100);
}
