#include "buffer.h"
#include "logmsg.h"
#include "getln.h"
#include "mess822.h"
#include "exit.h"

#define WHO "addrlist"

void nomem()
{
  logmsg(WHO,111,FATAL,"out of memory");
}

void put(char *buf)
{
  char ch;

  while ((ch = *buf)) {
    if (ch == '\n') ch = 0;
    buffer_put(buffer_1,&ch,1);
    ++buf;
  }
}

stralloc line = {0};
int match;

stralloc addrlist = {0};
stralloc quoted = {0};

int main()
{
  int i;
  int j;

  for (;;) {
    if (getln(buffer_0,&line,&match,'\n') == -1)
      logmsg(WHO,111,FATAL,"unable to read input: ");
    if (!line.len) break;
    if (match) --line.len;

    buffer_puts(buffer_1,"input {");
    buffer_put(buffer_1,line.s,line.len);
    buffer_puts(buffer_1,"}\n");

    for (i = 0; i < line.len; ++i)
      if (line.s[i] == 0)
        line.s[i] = '\n';

    if (!stralloc_0(&line)) nomem();

    if (!mess822_addrlist(&addrlist,line.s)) nomem();

    for (j = i = 0; j < addrlist.len; ++j)
      if (!addrlist.s[j]) {
        if (addrlist.s[i] == '(') {
           buffer_puts(buffer_1,"comment {");
           put(addrlist.s + i + 1);
           buffer_puts(buffer_1,"}\n");
        }
        else if (addrlist.s[i] == '+') {
          buffer_puts(buffer_1,"address {");
          put(addrlist.s + i + 1);
          buffer_puts(buffer_1,"}\n");
        }
        i = j + 1;
      }

    if (!mess822_quotelist(&quoted,&addrlist)) nomem();
    buffer_puts(buffer_1,"rewrite {");
    buffer_put(buffer_1,quoted.s,quoted.len);
    buffer_puts(buffer_1,"}\n");

    buffer_puts(buffer_1,"\n");
    if (!match) break;
  }

  buffer_flush(buffer_1);
  _exit(0);
}
