#include <sys/types.h>
#include <sys/stat.h>
#include "logmsg.h"
#include "readwrite.h"
#include "auto_home.h"
#include "exit.h"

extern void hier();

#define WHO "instcheck"

void perm (char *prefix1,char *prefix2,char *prefix3,char *file,int type,int uid,int gid,int mode)
{
  struct stat st;

  if (stat(file,&st) == -1) {
    if (errno == error_noent)
      logmsg(WHO,-1,WARN,B("file: ",prefix1,prefix2,prefix3,file," does not exist"));
    else
      logmsg(WHO,-1,WARN,B("unable to stat .../",file));
    return;
  }

  if ((uid != -1) && (st.st_uid != uid))
    logmsg(WHO,-1,WARN,B("file: ",prefix1,prefix2,prefix3,file," has wrong owner"));
  if ((gid != -1) && (st.st_gid != gid))
    logmsg(WHO,-1,WARN,B("file: ",prefix1,prefix2,prefix3,file," has wrong group"));
  if ((st.st_mode & 07777) != mode)
    logmsg(WHO,-1,WARN,B("file: ",prefix1,prefix2,prefix3,file," has wrong permissions"));
  if ((st.st_mode & S_IFMT) != type)
    logmsg(WHO,-1,WARN,B("file: ",prefix1,prefix2,prefix3,file," has wrong type"));
}

void h(char *home,int uid,int gid,int mode)
{
  perm("","","",home,S_IFDIR,uid,gid,mode);
}

void d(char *home,char *subdir,int uid,int gid,int mode)
{
  if (chdir(home) == -1)
    logmsg(WHO,111,FATAL,B("unable to switch to: ",home));
  perm("",home,"/",subdir,S_IFDIR,uid,gid,mode);
}

void p(char *home,char *fifo,int uid,int gid,int mode)
{
  if (chdir(home) == -1)
    logmsg(WHO,111,FATAL,B("unable to switch to: ",home));
  perm("",home,"/",fifo,S_IFIFO,uid,gid,mode);
}

void c(char *home,char *subdir,char *file,int uid,int gid,int mode)
{
  if (chdir(home) == -1)
    logmsg(WHO,111,FATAL,B("unable to switch to: ",home));
  if (chdir(subdir) == -1)
    logmsg(WHO,111,FATAL,B("unable to switch to: ",home,"/",subdir));
  perm(".../",subdir,"/",file,S_IFREG,uid,gid,mode);
}

void z(char *home,char *file,int len,int uid,int gid,int mode)
{
  if (chdir(home) == -1)
    logmsg(WHO,111,FATAL,B("unable to switch to: ",home));
  perm("",home,"/",file,S_IFREG,uid,gid,mode);
}

int main()
{
  hier();
  _exit(0);
}
