#include "buffer.h"
#include "logmsg.h"
#include "getln.h"
#include "mess822.h"
#include "leapsecs.h"
#include "caltime.h"
#include "tai.h"
#include "exit.h"

#define WHO "parsedate"

void nomem()
{
  logmsg(WHO,111,FATAL,"out of memory");
}

stralloc line = {0};
int match;

mess822_time t;
struct tai sec;

int main()
{
  int i;

  if (leapsecs_init() == -1)
    logmsg(WHO,111,FATAL,"unable to init leapsecs: ");

  for (;;) {
    if (getln(buffer_0,&line,&match,'\n') == -1)
      logmsg(WHO,111,FATAL,"unable to read input: ");
    if (!line.len) break;
    if (match) --line.len;

    for (i = 0; i < line.len; ++i)
      if (line.s[i] == 0)
        line.s[i] = '\n';
    if (!stralloc_0(&line)) nomem();

    t.known = 0;
    if (!mess822_when(&t,line.s)) nomem();

    if (t.known) {
      if (!stralloc_ready(&line,caltime_fmt((char *) 0,&t.ct))) nomem();
      buffer_put(buffer_1,line.s,caltime_fmt(line.s,&t.ct));
      if (t.known == 1)
        buffer_put(buffer_1,"?",1);
      buffer_put(buffer_1,"\t",1);
    
      caltime_tai(&t.ct,&sec);
    
      caltime_utc(&t.ct,&sec,(int *) 0,(int *) 0);
      if (!stralloc_ready(&line,caltime_fmt((char *) 0,&t.ct))) nomem();
      buffer_put(buffer_1,line.s,caltime_fmt(line.s,&t.ct));
    }

    buffer_puts(buffer_1,"\n");
    if (!match) break;
  }

  buffer_flush(buffer_1);
  _exit(0);
}
